



#include <Arduino.h>
#include <LiquidCrystal.h>


//const int rs = 5, en = 6, d4 = 10, d5 = 7, d6 = 8, d7 = 9; // пины управления дисплеем PCB v1
const int rs = 5, en = 6, d4 = 7, d5 = 8, d6 = 9, d7 = 10; // пины управления дисплеем PCB v2

LiquidCrystal lcd(rs, en, d4, d5, d6, d7);



//LiquidCrystal lcd(8, 9, 4, 5, 6, 7);// для arduino шилд


// 74HC595 
#define PinClock     2         //на микросхеме CLOCK  11 нога . на плате, если минус первая нога, то 4 пин
#define PinStrobe    3         //на микросхеме STROBE 12 нога . на плате, если минус первая нога, то 3 пин
#define PinData      4         //на микросхеме DATA   14 нога . на плате, если минус первая нога, то 2 пин

// Энкодер 
#define PinEncA      11      // сигнал А энкодера  
#define PinEncB      12      // сигнал B энкодера  
#define PinEncC      13      // кнопка энкодера  

#define TimerRefreshHC595 60000   // задержка перед срабатыванием реле в попугаях
#define DefPos      66            // стартовое положение энкодера 
//------------------------------------------------------------------------------------------

long               FlagRefreshHC595=TimerRefreshHC595;
volatile  boolean  Pin_OldValue=LOW;
volatile  byte     EncoderPos=DefPos;           // предустановленное значение ослабления 66 dB
byte               OldEncoderPos=0;

unsigned int Timer = 65520;   //пред делитель опроса энкодера



                       
//float Db_to_v(byte value)   // перевод DB в volt  для входных 100mv
//{
//return 100.0 / (pow (10,  (value /20.0)));  
//}


void writeHC595(byte Data)
 {
    static unsigned char Reg;
    Data=127-Data;                                 // используется если выход регистров реверсивный (вместо единицы ноль)
     if (Data>95) Reg=Data|128;                    // вычисление значение для записи в регистр HC595 
         else if (Data>63) Reg=Data|32;            // 
         else Reg=Data;                            //
        
    digitalWrite(PinStrobe, LOW);                  //подготовка
    shiftOut(PinData, PinClock, MSBFIRST, Reg);    // запись
    digitalWrite(PinStrobe, HIGH);                 //фиксация
 }


//---------------------------------------------------
void  IsrSetting()
  {
  noInterrupts();                                    // отключаем все прерывания
  TCCR1A = 0;                                        // настройка таймера прерывания
  TCCR1B = 0;
  TCNT1 = Timer;                                     // preload timer
  TCCR1B |= (1 << CS10)|(1 << CS12);                 // 1024 коэффициент деления предделителя
  TIMSK1 |= (1 << TOIE1);                            // разрешаем вызов процедуры обработки прерывания переполнения счетчика
  interrupts();  
  }
//---------------------------------------------------
ISR (TIMER1_OVF_vect)
{
  boolean Pin1,Pin2,Key;
  TCNT1 = Timer;
  
    Pin1=digitalRead(PinEncA);                          // чтение всех пинов энкодера
    Pin2=digitalRead(PinEncB);
    Key= digitalRead(PinEncC);

    if ((Pin_OldValue==LOW) and (Pin1==HIGH))           //  ексли энкодер вращали
         {
          if (Key == HIGH)
           {                   // медленное приращение
            if (Pin2==HIGH) 
             {  if( EncoderPos < 127) EncoderPos++;}
            else
             { if ( EncoderPos > 0  ) EncoderPos--;}
           }
         else
           {                      //  быстрое приращение
             if (Pin2==HIGH) 
               {  if( EncoderPos < 117) EncoderPos=EncoderPos+10;}
              else
               { if ( EncoderPos > 10 ) EncoderPos=EncoderPos-10;}
           }
         }
 
    Pin_OldValue=Pin1;                                       // сохранение текущего состояния сигнала A 
 
}



//---------------------------------------------------------------------------
void setup() 
{
// Serial.begin(9600);

  pinMode(PinClock, OUTPUT);          // 74HC595 
  pinMode(PinData,  OUTPUT);          // 
  pinMode(PinStrobe,OUTPUT);          // 

  pinMode(PinEncA,INPUT_PULLUP);             // энкодер  
  pinMode(PinEncB,INPUT_PULLUP);             // 
  pinMode(PinEncC,INPUT_PULLUP);             // 

  writeHC595(DefPos);                       //при стартовое положение регистров реле

  lcd.begin(16, 2);
  lcd.clear();
  lcd.setCursor(0,0);lcd.print("   ATT 128 dB   ");
  lcd.setCursor(0,1);lcd.print("INPUT 100 mV RMS");

  delay(2000);
  lcd.setCursor(0,0);lcd.print ("ATT             ");
  lcd.setCursor(0,1);lcd.print ("OUT             ");

  Pin_OldValue =  digitalRead(PinEncA);

  IsrSetting();


}
//---------------------------------------------------------------------------

void ShowLcd(byte dB_n)
{                                                    // основной вывод информации на дисплей
  lcd.setCursor(5,0);lcd.print("     ");
  lcd.setCursor(5,0);lcd.print(dB_n);   
  lcd.setCursor(10,0);lcd.print("dB");
  lcd.setCursor(5,1);lcd.print(szATT_100mV[dB_n]);
}

//-----------------------------------------------------------------------------


void loop() 
{

  byte dB_Value=EncoderPos;                            // защита от рассинхрона в многопоточности

  if ( OldEncoderPos != dB_Value)                      // если значение позиции энкодера изменилось
    {   
      OldEncoderPos = dB_Value;
      ShowLcd(dB_Value);                                // отобразить на дисплее новые значения
      FlagRefreshHC595=TimerRefreshHC595;  
    }
         
   if (FlagRefreshHC595 > -1)   FlagRefreshHC595--;
   
   if (FlagRefreshHC595 == 0)                            // проверка задержки переключения реле
      {
         writeHC595(dB_Value);                           // Обновление регистров HC595 
         FlagRefreshHC595=-1;     
      }
  }
  
